package com.voztele.wesip.test;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.sip.SipFactory;
import javax.servlet.sip.SipServlet;
import javax.servlet.sip.SipServletRequest;
import javax.servlet.sip.SipServletResponse;
import javax.servlet.sip.SipSession;
import javax.servlet.sip.SipURI;

public class B2BUATestApp extends SipServlet{

	private SipFactory sf;

	public void init() throws ServletException {
		this.sf = (SipFactory) getServletContext().getAttribute(SIP_FACTORY);
	}
	
	protected void doInvite(SipServletRequest invite) throws ServletException, IOException {
		
		SipServletRequest otherInvite = sf.createRequest(invite, false);
		SipURI sipUri = sf.createSipURI("UA1", "proxy");
		otherInvite.setRequestURI(sipUri);
		
		otherInvite.getSession().setAttribute("REQUEST", otherInvite);
		otherInvite.getSession().setAttribute("PEER_SESSION", invite.getSession());
		invite.getSession().setAttribute("PEER_SESSION", otherInvite.getSession());
		invite.getSession().setAttribute("REQUEST", invite);
		otherInvite.send();
	}
	
	
	protected void doErrorResponse(SipServletResponse errorResponse) throws ServletException, IOException {
		switch(errorResponse.getStatus()){
			case 486:
				SipServletRequest request = (SipServletRequest) errorResponse.getSession().getAttribute("REQUEST");
				SipSession otherSession = (SipSession) errorResponse.getSession().getAttribute("PEER_SESSION");
				SipURI sipUri = sf.createSipURI("UA2", "proxy");
				request.setRequestURI(sipUri);
				SipServletRequest newRequest = sf.createRequest(request,false);
				newRequest.getSession().setAttribute("REQUEST", newRequest);
				newRequest.getSession().setAttribute("PEER_SESSION", otherSession);
				otherSession.setAttribute("PEER_SESSION", newRequest.getSession());
				newRequest.send();
				break;
		}
	}
	
	protected void doSuccessResponse(SipServletResponse resp) throws ServletException, IOException {
		String method = resp.getMethod();
		switch(resp.getStatus()){
			case 200:
				if(method.equals("INVITE")){
					SipSession otherSession = (SipSession) resp.getSession().getAttribute("PEER_SESSION");
					SipServletRequest otherInvite = (SipServletRequest) otherSession.getAttribute("REQUEST");
					SipServletResponse otherResponse = otherInvite.createResponse(200);
					otherResponse.setContent(resp.getContent(), resp.getContentType());
					otherResponse.send();
					resp.createAck().send();
				}
				break;
		}
	}
	
	protected void doBye(SipServletRequest bye) throws ServletException, IOException {
		SipSession otherSession = (SipSession) bye.getSession().getAttribute("PEER_SESSION");
		otherSession.createRequest("BYE").send();
		bye.createResponse(200).send();
	}
}
